Index: palm/trunk/SOURCE/radiation_model.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model.f90	(revision 1584)
+++ palm/trunk/SOURCE/radiation_model.f90	(revision 1585)
@@ -15,10 +15,10 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! Added support for RRTMG
 ! 
 ! Former revisions:
@@ -40,68 +40,262 @@
 ! Description:
 ! ------------
-! Radiation model(s), to be used e.g. with the land surface scheme
+! Radiation models and interfaces
+! To do: move variable definitions used in init_radiation only to the subroutine
+! as they are no longer required after initialization.
+! Note that many variables have a leading dummy dimension (0:0) in order to
+! match the assume-size shape expected by the RRTMG model
+!
+! To do:
+! - Output of full column vertical profiles used in RRTMG
+! - Output of other rrtm arrays (such as volume mixing ratios)
+! - Adapt for use with topography
+! - Remove 3D dummy arrays (such as clear-sky output)
 !------------------------------------------------------------------------------!
 
     USE arrays_3d,                                                             &
-        ONLY: pt
+        ONLY:  hyp, pt, q, ql, zw
+
+    USE cloud_parameters,                                                      &
+        ONLY:  cp, l_v, nc_const, rho_l, sigma_gc  
+
+    USE constants,                                                             &
+        ONLY:  pi
 
     USE control_parameters,                                                    &
-        ONLY: phi, surface_pressure, time_since_reference_point
+        ONLY:  cloud_droplets, cloud_physics, g, initializing_actions,         &
+               large_scale_forcing, lsf_surf, phi, pt_surface,                 &
+               surface_pressure, time_since_reference_point
 
     USE indices,                                                               &
-        ONLY:  nxlg, nxrg, nyng, nysg, nzb_s_inner
+        ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb_s_inner, nzb, nzt
 
     USE kinds
+
+    USE netcdf
 
     USE netcdf_control,                                                        &
         ONLY:  dots_label, dots_num, dots_unit
 
+#if defined ( __rrtmg )
+    USE parrrsw,                                                               &
+        ONLY:  naerec, nbndsw
+
+    USE parrrtm,                                                               &
+        ONLY:  nbndlw
+
+    USE rrtmg_lw_init,                                                         &
+        ONLY:  rrtmg_lw_ini
+
+    USE rrtmg_sw_init,                                                         &
+        ONLY:  rrtmg_sw_ini
+
+    USE rrtmg_lw_rad,                                                          &
+        ONLY:  rrtmg_lw
+
+    USE rrtmg_sw_rad,                                                          &
+        ONLY:  rrtmg_sw
+#endif
+
+
 
     IMPLICIT NONE
 
-    CHARACTER(10) :: radiation_scheme = 'clear-sky' ! 'constant', 'clear-sky', or 'rrtm'
-
-    INTEGER(iwp) :: i, j, k
-
-
-    INTEGER(iwp) :: day_init     = 172,  & !: day of the year at model start (21/06)
-                    dots_rad     = 0,    & !: starting index for timeseries output 
-                    irad_scheme  = 0
-
-    LOGICAL :: radiation = .FALSE.  !: flag parameter indicating wheather the radiation model is used
-
-    REAL(wp), PARAMETER :: sw_0 = 1368.0_wp, &    !: solar constant  
-                           pi = 3.14159265358979323_wp, &
-                           sigma_sb  = 5.67E-8_wp !: Stefan-Boltzmann constant
+    CHARACTER(10) :: radiation_scheme = 'clear-sky' ! 'constant', 'clear-sky', or 'rrtmg'
+
+!
+!-- Predefined Land surface classes (albedo_type) after Briegleb (1992)
+    CHARACTER(37), DIMENSION(0:16), PARAMETER :: albedo_type_name = (/    &
+                                   'user defined',                         & !  0 
+                                   'ocean',                                & !  1
+                                   'mixed farming, tall grassland',        & !  2
+                                   'tall/medium grassland',                & !  3 
+                                   'evergreen shrubland',                  & !  4
+                                   'short grassland/meadow/shrubland',     & !  5
+                                   'evergreen needleleaf forest',          & !  6
+                                   'mixed deciduous evergreen forest',     & !  7
+                                   'deciduous forest',                     & !  8
+                                   'tropical evergreen broadleaved forest',& !  9
+                                   'medium/tall grassland/woodland',       & ! 10
+                                   'desert, sandy',                        & ! 11 
+                                   'desert, rocky',                        & ! 12 
+                                   'tundra',                               & ! 13
+                                   'landice',                              & ! 14 
+                                   'sea ice',                              & ! 15 
+                                   'snow'                                  & ! 16
+                                                         /)
+
+    INTEGER(iwp) :: albedo_type  = 5,    & !: Albedo surface type (default: short grassland)
+                    day,                 & !: current day of the year
+                    day_init     = 172,  & !: day of the year at model start (21/06)
+                    dots_rad     = 0       !: starting index for timeseries output 
+
+
+
+
+
+
+    LOGICAL ::  constant_albedo = .FALSE., & !: flag parameter indicating whether the albedo may change depending on zenith
+                lw_radiation = .TRUE.,     & !: flag parameter indicing whether longwave radiation shall be calculated
+                radiation = .FALSE.,       & !: flag parameter indicating whether the radiation model is used
+                sun_up    = .TRUE.,        & !: flag parameter indicating whether the sun is up or down
+                sw_radiation = .TRUE.        !: flag parameter indicing whether shortwave radiation shall be calculated
+
+    REAL(wp), PARAMETER :: sigma_sb       = 5.67E-8_wp, & !: Stefan-Boltzmann constant
+                           solar_constant = 1368.0_wp     !: solar constant at top of atmosphere
  
-    REAL(wp) :: albedo = 0.2_wp,             & !: NAMELIST alpha
-                dt_radiation = 0.0_wp,       & !: radiation model timestep
-                exn,                         & !: Exner function
-                lon = 0.0_wp,                & !: longitude in radians
-                lat = 0.0_wp,                & !: latitude in radians
-                decl_1,                      & !: declination coef. 1
-                decl_2,                      & !: declination coef. 2
-                decl_3,                      & !: declination coef. 3
-                time_utc,                    & !: current time in UTC
-                time_utc_init = 43200.0_wp,  & !: UTC time at model start (noon)
-                day,                         & !: current day of the year
-                lambda = 0.0_wp,             & !: longitude in degrees
-                declination,                 & !: solar declination angle
-                net_radiation = 0.0_wp,      & !: net radiation at surface
-                hour_angle,                  & !: solar hour angle
-                time_radiation = 0.0_wp,     &
-                zenith,                      & !: solar zenith angle
-                sky_trans                      !: sky transmissivity
+    REAL(wp) :: albedo = 9999999.9_wp,        & !: NAMELIST alpha
+                albedo_lw_dif = 9999999.9_wp, & !: NAMELIST aldif
+                albedo_lw_dir = 9999999.9_wp, & !: NAMELIST aldir
+                albedo_sw_dif = 9999999.9_wp, & !: NAMELIST asdif
+                albedo_sw_dir = 9999999.9_wp, & !: NAMELIST asdir
+                dt_radiation = 0.0_wp,        & !: radiation model timestep
+                emissivity = 0.95_wp,         & !: NAMELIST surface emissivity
+                exn,                          & !: Exner function
+                lon = 0.0_wp,                 & !: longitude in radians
+                lat = 0.0_wp,                 & !: latitude in radians
+                decl_1,                       & !: declination coef. 1
+                decl_2,                       & !: declination coef. 2
+                decl_3,                       & !: declination coef. 3
+                time_utc,                     & !: current time in UTC
+                time_utc_init = 43200.0_wp,   & !: UTC time at model start (noon)
+                lambda = 0.0_wp,              & !: longitude in degrees
+                net_radiation = 0.0_wp,       & !: net radiation at surface
+                time_radiation = 0.0_wp,      & !: time since last call of radiation code
+                sky_trans                       !: sky transmissivity
+
+
+    REAL(wp), DIMENSION(0:0) ::  zenith        !: solar zenith angle
 
     REAL(wp), DIMENSION(:,:), ALLOCATABLE :: &
-                alpha,                       & !: surface albedo
+                alpha,                       & !: surface broadband albedo (used for clear-sky scheme)
                 rad_net,                     & !: net radiation at the surface
-                rad_net_av,                  & !: average of rad_net
-                rad_lw_in,                   & !: incoming longwave radiation
-                rad_lw_out,                  & !: outgoing longwave radiation
-                rad_sw_in,                   & !: incoming shortwave radiation
-                rad_sw_in_av,                & !: average of rad_sw_in
-                rad_sw_out                     !: outgoing shortwave radiation
-
+                rad_net_av                     !: average of rad_net
+
+!
+!-- Land surface albedos for solar zenith angle of 60Â° after Briegleb (1992)     
+!-- (shortwave, longwave, broadband):   sw,      lw,      bb,
+    REAL(wp), DIMENSION(0:2,1:15), PARAMETER :: albedo_pars = RESHAPE( (/& 
+                                   0.06_wp, 0.06_wp, 0.06_wp,            & !  1
+                                   0.09_wp, 0.28_wp, 0.19_wp,            & !  2
+                                   0.11_wp, 0.33_wp, 0.23_wp,            & !  3
+                                   0.11_wp, 0.33_wp, 0.23_wp,            & !  4
+                                   0.14_wp, 0.34_wp, 0.25_wp,            & !  5
+                                   0.06_wp, 0.22_wp, 0.14_wp,            & !  6
+                                   0.06_wp, 0.27_wp, 0.17_wp,            & !  7
+                                   0.06_wp, 0.31_wp, 0.19_wp,            & !  8
+                                   0.06_wp, 0.22_wp, 0.14_wp,            & !  9
+                                   0.06_wp, 0.28_wp, 0.18_wp,            & ! 10
+                                   0.35_wp, 0.51_wp, 0.43_wp,            & ! 11
+                                   0.24_wp, 0.40_wp, 0.32_wp,            & ! 12
+                                   0.10_wp, 0.27_wp, 0.19_wp,            & ! 13
+                                   0.90_wp, 0.65_wp, 0.77_wp,            & ! 14
+                                   0.95_wp, 0.70_wp, 0.82_wp             & ! 15
+                                 /), (/ 3, 15 /) )
+
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET :: &
+                        rad_sw_in,                     & !: incoming shortwave radiation (W/m2)
+                        rad_sw_in_av,                  & !: average of rad_sw_in
+                        rad_sw_out,                    & !: outgoing shortwave radiation (W/m2)
+                        rad_sw_out_av,                 & !: average of rad_sw_out
+                        rad_lw_in,                     & !: incoming longwave radiation (W/m2)
+                        rad_lw_in_av,                  & !: average of rad_lw_in
+                        rad_lw_out,                    & !: outgoing longwave radiation (W/m2)
+                        rad_lw_out_av                    !: average of rad_lw_out
+
+!
+!-- Variables and parameters used in RRTMG only
+#if defined ( __rrtmg )
+    CHARACTER(LEN=12) :: rrtm_input_file = "RAD_SND_DATA" !: name of the NetCDF input file (sounding data)
+
+
+!
+!-- Flag parameters for RRTMGS (should not be changed)
+    INTEGER(iwp), PARAMETER :: rrtm_inflglw  = 2, & !: flag for lw cloud optical properties (0,1,2)
+                               rrtm_iceflglw = 0, & !: flag for lw ice particle specifications (0,1,2,3)
+                               rrtm_liqflglw = 1, & !: flag for lw liquid droplet specifications
+                               rrtm_inflgsw  = 2, & !: flag for sw cloud optical properties (0,1,2)
+                               rrtm_iceflgsw = 0, & !: flag for sw ice particle specifications (0,1,2,3)
+                               rrtm_liqflgsw = 1    !: flag for sw liquid droplet specifications
+
+!
+!-- The following variables should be only changed with care, as this will 
+!-- require further setting of some variables, which is currently not
+!-- implemented (aerosols, ice phase).
+    INTEGER(iwp) :: nzt_rad,           & !: upper vertical limit for radiation calculations
+                    rrtm_icld = 0,     & !: cloud flag (0: clear sky column, 1: cloudy column)
+                    rrtm_iaer = 0,     & !: aerosol option flag (0: no aerosol layers, for lw only: 6 (requires setting of rrtm_sw_ecaer), 10: one or more aerosol layers (not implemented)
+                    rrtm_idrv = 0        !: longwave upward flux calculation option (0,1)
+
+    LOGICAL :: snd_exists = .FALSE.      !: flag parameter to check whether a user-defined input files exists
+
+    REAL(wp), PARAMETER :: mol_weight_air_d_wv = 1.607793_wp !: molecular weight dry air / water vapor
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE :: hyp_snd,     & !: hypostatic pressure from sounding data (hPa)
+                                           q_snd,       & !: specific humidity from sounding data (kg/kg) - dummy at the moment
+                                           rrtm_tsfc,   & !: dummy array for storing surface temperature
+                                           t_snd          !: actual temperature from sounding data (hPa)
+
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: aldif,         & !: longwave diffuse albedo solar angle of 60Â°
+                                             aldir,         & !: longwave direct albedo solar angle of 60Â°
+                                             asdif,         & !: shortwave diffuse albedo solar angle of 60Â°
+                                             asdir,         & !: shortwave direct albedo solar angle of 60Â°
+                                             rrtm_ccl4vmr,  & !: CCL4 volume mixing ratio (g/mol)
+                                             rrtm_cfc11vmr, & !: CFC11 volume mixing ratio (g/mol)
+                                             rrtm_cfc12vmr, & !: CFC12 volume mixing ratio (g/mol)
+                                             rrtm_cfc22vmr, & !: CFC22 volume mixing ratio (g/mol)
+                                             rrtm_ch4vmr,   & !: CH4 volume mixing ratio
+                                             rrtm_cicewp,   & !: in-cloud ice water path (g/mÂ²)
+                                             rrtm_cldfr,    & !: cloud fraction (0,1)
+                                             rrtm_cliqwp,   & !: in-cloud liquid water path (g/mÂ²)
+                                             rrtm_co2vmr,   & !: CO2 volume mixing ratio (g/mol)
+                                             rrtm_emis,     & !: surface emissivity (0-1)    
+                                             rrtm_h2ovmr,   & !: H2O volume mixing ratio
+                                             rrtm_n2ovmr,   & !: N2O volume mixing ratio
+                                             rrtm_o2vmr,    & !: O2 volume mixing ratio
+                                             rrtm_o3vmr,    & !: O3 volume mixing ratio
+                                             rrtm_play,     & !: pressure layers (hPa, zu-grid)
+                                             rrtm_plev,     & !: pressure layers (hPa, zw-grid)
+                                             rrtm_reice,    & !: cloud ice effective radius (microns)
+                                             rrtm_reliq,    & !: cloud water drop effective radius (microns)
+                                             rrtm_tlay,     & !: actual temperature (K, zu-grid)
+                                             rrtm_tlev,     & !: actual temperature (K, zw-grid)
+                                             rrtm_lwdflx,   & !: RRTM output of incoming longwave radiation flux (W/m2)
+                                             rrtm_lwuflx,   & !: RRTM output of outgoing longwave radiation flux (W/m2)
+                                             rrtm_lwhr,     & !: RRTM output of longwave radiation heating rate (K/d)
+                                             rrtm_lwuflxc,  & !: RRTM output of incoming clear sky longwave radiation flux (W/m2)
+                                             rrtm_lwdflxc,  & !: RRTM output of outgoing clear sky longwave radiation flux (W/m2) 
+                                             rrtm_lwhrc,    & !: RRTM output of incoming longwave clear sky radiation heating rate (K/d)
+                                             rrtm_swdflx,   & !: RRTM output of incoming shortwave radiation flux (W/m2)
+                                             rrtm_swuflx,   & !: RRTM output of outgoing shortwave radiation flux (W/m2)
+                                             rrtm_swhr,     & !: RRTM output of shortwave radiation heating rate (K/d)
+                                             rrtm_swuflxc,  & !: RRTM output of incoming clear sky shortwave radiation flux (W/m2)
+                                             rrtm_swdflxc,  & !: RRTM output of outgoing clear sky shortwave radiation flux (W/m2) 
+                                             rrtm_swhrc       !: RRTM output of incoming shortwave clear sky radiation heating rate (K/d) 
+
+!
+!-- Definition of arrays that are currently not used for calling RRTMG (due to setting of flag parameters)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  rad_lw_cs_in,   & !: incoming clear sky longwave radiation (W/m2) (not used)
+                                                rad_lw_cs_out,  & !: outgoing clear sky longwave radiation (W/m2) (not used)
+                                                rad_lw_cs_hr,   & !: longwave clear sky radiation heating rate (K/d) (not used)
+                                                rad_lw_hr,      & !: longwave radiation heating rate (K/d)
+                                                rad_sw_cs_in,   & !: incoming clear sky shortwave radiation (W/m2) (not used)
+                                                rad_sw_cs_out,  & !: outgoing clear sky shortwave radiation (W/m2) (not used)
+                                                rad_sw_cs_hr,   & !: shortwave clear sky radiation heating rate (K/d) (not used)
+                                                rad_sw_hr,      & !: shortwave radiation heating rate (K/d)
+                                                rrtm_aldif,     & !: surface albedo for longwave diffuse radiation
+                                                rrtm_aldir,     & !: surface albedo for longwave direct radiation
+                                                rrtm_asdif,     & !: surface albedo for shortwave diffuse radiation
+                                                rrtm_asdir,     & !: surface albedo for shortwave direct radiation
+                                                rrtm_lw_tauaer, & !: lw aerosol optical depth
+                                                rrtm_lw_taucld, & !: lw in-cloud optical depth
+                                                rrtm_sw_taucld, & !: sw in-cloud optical depth
+                                                rrtm_sw_ssacld, & !: sw in-cloud single scattering albedo
+                                                rrtm_sw_asmcld, & !: sw in-cloud asymmetry parameter
+                                                rrtm_sw_fsfcld, & !: sw in-cloud forward scattering fraction
+                                                rrtm_sw_tauaer, & !: sw aerosol optical depth
+                                                rrtm_sw_ssaaer, & !: sw aerosol single scattering albedo
+                                                rrtm_sw_asmaer, & !: sw aerosol asymmetry parameter
+                                                rrtm_sw_ecaer     !: sw aerosol optical detph at 0.55 microns (rrtm_iaer = 6 only)
+#endif
 
     INTERFACE init_radiation
@@ -113,12 +307,12 @@
     END INTERFACE radiation_clearsky
 
-    INTERFACE radiation_constant
-       MODULE PROCEDURE radiation_constant
-    END INTERFACE radiation_constant
-
-    INTERFACE radiation_rrtm
-       MODULE PROCEDURE radiation_rrtm
-    END INTERFACE radiation_rrtm
-
+    INTERFACE radiation_rrtmg
+       MODULE PROCEDURE radiation_rrtmg
+    END INTERFACE radiation_rrtmg
+
+    INTERFACE radiation_tendency
+       MODULE PROCEDURE radiation_tendency
+       MODULE PROCEDURE radiation_tendency_ij
+    END INTERFACE radiation_tendency
 
     SAVE
@@ -126,11 +320,16 @@
     PRIVATE
 
-    PUBLIC albedo, day_init, dots_rad, dt_radiation, init_radiation,           &
-           irad_scheme, lambda, net_radiation, rad_net, rad_net_av, radiation, &
-           radiation_clearsky, radiation_constant, radiation_rrtm,             &
-           radiation_scheme, rad_sw_in, rad_sw_in_av, sigma_sb,                &
-           time_radiation, time_utc_init 
-
-
+    PUBLIC albedo, albedo_type, albedo_type_name, albedo_lw_dif, albedo_lw_dir,&
+           albedo_sw_dif, albedo_sw_dir, constant_albedo, day_init, dots_rad,  &
+           dt_radiation, init_radiation, lambda, lw_radiation, net_radiation,  &
+           rad_net, rad_net_av, radiation, radiation_clearsky,                 &
+           radiation_rrtmg, radiation_scheme, radiation_tendency, rad_lw_in,   &
+           rad_lw_in_av, rad_lw_out, rad_lw_out_av, rad_sw_in, rad_sw_in_av,   &
+           rad_sw_out, rad_sw_out_av, sigma_sb, sw_radiation, time_radiation,  &
+           time_utc_init 
+
+#if defined ( __rrtmg )
+    PUBLIC rrtm_aldif, rrtm_aldir, rrtm_asdif, rrtm_asdir
+#endif
 
  CONTAINS
